﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Problems.GPDL;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Test {
  [TestClass]
  public class TestGpdlCompiler {
    [TestMethod]
    public void TestDuplicateSymbol() {
      Scanner scanner = new Scanner("DupSymbol.gpdl");
      Parser parser = new Parser(scanner);
      try {
        parser.Parse();
        Assert.Fail("Exception about duplicate symbol expected");
      }
      catch (FatalError e) {
        // exception is expected
      }
    }
    [TestMethod]
    public void TestMissingRule() {
      Scanner scanner = new Scanner("MissingRule.gpdl");
      Parser parser = new Parser(scanner);
      try {
        parser.Parse();
        Assert.Fail("Exception about missing rule expected");
      }
      catch (FatalError e) {
        // exception is expected
      }
    }
    [TestMethod]
    public void TestNoNonTerminal() {
      Scanner scanner = new Scanner("NoNonTerminal.gpdl");
      Parser parser = new Parser(scanner);
      try {
        parser.Parse();
        Assert.Fail("Exception about non-terminals expected");
      }
      catch (FatalError e) {
        // exception is expected
      }
    }
  }
}
